import es,playerlib,cmdlib
import Config
from RepeatTimer import RepeatTimer

info 					= es.AddonInfo()
info.name 		= 'Bennit\' advertisements'
info.version 	= '1.0'
info.basename = 'badverts'
info.url 			= 'http://bennit.be'
info.author 	= 'Bennit^'

config = Config.Config('config.cfg',info) # TOO MANY CONFIG'S yiAaaAAARGH
timers = []

def undefine():
	cmdlib.unregisterServerCommand('adverts_debug_clean')
	for adlist in config.adlists:
		cmdlib.unregisterServerCommand(adlist.addcmd)

def define():
	cmdlib.registerServerCommand(
			'adverts_debug_clean',
			(lambda args:undefine()),
			'debugging purposes of adverts eventscript')

def startAds(ads,printer,every):
	pos = [0]
	
	def loop():
		pos[0] = (pos[0] + 1) % len(ads) # dirty hack to allow nonlocal assignment (py3k allows it, 2.6 and down don't)
		ad = ads[pos[0]]
		if type(ad) != type(""):
			ad = ad()
		printer(ad,[]) # TODO -- add extra optional parameters
	
	if len(ads) > 0:
		timer = RepeatTimer.newEternal(loop,every)
		timers.append(timer)
		timer.start()

def load():
	define()
	config.config.execute()
	for adlist in config.adlists:
		startAds(adlist.ads,adlist.printer,adlist.interval)
	es.dbgmsg(0,info.name+' - by - '+info.author)


def unload():
	undefine()
	for timer in timers:
		timer.kill()
